clang 8.0.0

Classes | Public Member Functions | Protected Member Functions | List of all members
clang::CodeGen::EHScopeStack::Cleanup Class Referenceabstract

Information for lazily generating a cleanup. More...

`#include "/work/www-prereleases/8.0.0/rc2/builddocs/llvm.src/tools/clang/lib/CodeGen/EHScopeStack.h"`

Inheritance diagram for clang::CodeGen::EHScopeStack::Cleanup:
[legend]

## Classes
class | Flags
| Generation flags. More...

## Public Member Functions
| Cleanup (const Cleanup &)=default
| Cleanup (Cleanup &&)
| Cleanup ()=default
virtual void | Emit (CodeGenFunction &CGF, Flags flags)=0
| Emit the cleanup. More...

## Protected Member Functions
| ~Cleanup ()=default

## Detailed Description

Information for lazily generating a cleanup.

Subclasses must be POD-like: cleanups will not be destructed, and they will be allocated on the cleanup stack and freely copied and moved around.

Cleanup implementations should generally be declared in an anonymous namespace.

Definition at line 147 of file EHScopeStack.h.

## Constructor & Destructor Documentation

## ◆ ~Cleanup()

clang::CodeGen::EHScopeStack::Cleanup::~Cleanup | ( |  | ) |
| protected default

## ◆ Cleanup() [1/3]

clang::CodeGen::EHScopeStack::Cleanup::Cleanup | ( | const Cleanup & |  | ) |
| default

## ◆ Cleanup() [2/3]

clang::CodeGen::EHScopeStack::Cleanup::Cleanup | ( | Cleanup && |  | ) |
| inline

Definition at line 156 of file EHScopeStack.h.

## ◆ Cleanup() [3/3]

clang::CodeGen::EHScopeStack::Cleanup::Cleanup | ( |  | ) |
| default

## Member Function Documentation

## ◆ Emit()

virtual void clang::CodeGen::EHScopeStack::Cleanup::Emit | ( | CodeGenFunction & | CGF,
|  | Flags | flags
| ) |  |
| pure virtual

Emit the cleanup.

For normal cleanups, this is run in the same EH context as when the cleanup was pushed, i.e. the immediately-enclosing context of the cleanup scope. For EH cleanups, this is run in a terminate context.

Implemented in CleanupTy, clang::CodeGen::CatchRetScope, and clang::CodeGen::CodeGenFunction::CallLifetimeEnd.

Referenced by EmitCleanup().

The documentation for this class was generated from the following files:

- lib/CodeGen/EHScopeStack.h
- lib/CodeGen/CGCleanup.cpp